<template>
  <q-page class="backg q-pa-md grid" >
    <div class="bg-grey-6 container"
      :style="unsolvable==true?(complete==true?'border-color:orange':'border-color:maroon'):'border-color:lightgrey'">

      <div class="row flex-center q-my-sm">
        <grid-box :boxRow='1' :boxCol='1' />
        <grid-box :boxRow='1' :boxCol='2' />
        <grid-box :boxRow='1' :boxCol='3' />
      </div>
      <div class="row flex-center q-my-sm">
        <grid-box :boxRow='2' :boxCol='1' />
        <grid-box :boxRow='2' :boxCol='2' />
        <grid-box :boxRow='2' :boxCol='3' />
      </div>
      <div class="row flex-center q-my-sm">
        <grid-box :boxRow='3' :boxCol='1' />
        <grid-box :boxRow='3' :boxCol='2' />
        <grid-box :boxRow='3' :boxCol='3' />
      </div>

    </div>
    <div class="q-ma-lg column ">
      <div class="col self-center">
        <q-btn
        color="primary"
        class="q-ma-sm q-py-sm"
        label="reset"
        @click="reset()"
        />
      <q-btn
        :color="unsolvable == true ? 'primary' :'grey-4'"
        :text-color="unsolvable == true? 'white' : 'primary'"
        class="q-ma-sm q-px-xl q-py-sm"
        label="solve"
        @click="solve()"
        :disable="unsolvable"
        />
      </div>

    </div>
  </q-page>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import GridBox from 'components/GridBox'

export default {
  name: 'PageIndex',
  components: {
    GridBox
  },
  data () {
    return {
      unsolvable: true,
      complete: false
    }
  },
  computed: {
    ...mapGetters('grid', ['editIndex', 'grid', 'solvable'])
  },
  methods: {
    ...mapActions('grid', ['initializeGrid', 'updateGrid', 'changeEditIndex', 'solveGrid', 'resetGrid']),
    insertNumber (n) {
      if (this.editIndex >= 0) {
        this.updateGrid(n)
        this.changeEditIndex(-1)
        this.unsolvable = !this.solvable
        this.$root.$emit('reset')
      }
    },
    deleteNumber () {
      if (this.editIndex >= 0) {
        this.updateGrid(0)
        this.unsolvable = !this.solvable
      }
    },
    solve () {
      this.solveGrid()
      this.unsolvable = !this.solvable
      this.complete = true
    },
    reset () {
      this.resetGrid()
      console.clear()
      this.unsolvable = false
      this.complete = false
    }
  },
  created () {
    this.initializeGrid()
    this.unsolvable = !this.solvable
    console.log('INITIALIZED', this.grid)
  },
  mounted () {
    window.addEventListener('keydown', e => {
      console.log(`keypress : charValue = ${String.fromCharCode(e.keyCode)}`)
      console.log('keydown : keyCode = ', e.keyCode)
      if (e.keyCode === 8 || e.keyCode === 46) {
        this.deleteNumber()
      } else {
        this.insertNumber(Number.parseInt(String.fromCharCode(e.keyCode)))
      }
    })
  }
}
</script>

<style scoped>
  .grid {
    min-width: 500px;
  }
  .container{
    max-width: 470px;
    margin: auto;
    padding: 4px;
    border: 4px solid;
    border-radius: 16px;
  }
</style>
